/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEB_AUDIO)

#include "JSAudioDestinationNode.h"

#include "AudioDestinationNode.h"
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

ASSERT_CLASS_FITS_IN_CELL(JSAudioDestinationNode);

/* Hash table */
#if ENABLE(JIT)
#define THUNK_GENERATOR(generator) , generator
#else
#define THUNK_GENERATOR(generator)
#endif

static const HashTableValue JSAudioDestinationNodeTableValues[3] =
{
    { "numberOfChannels", DontDelete | ReadOnly, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAudioDestinationNodeNumberOfChannels), (intptr_t)0 THUNK_GENERATOR(0) },
    { "constructor", DontEnum | ReadOnly, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAudioDestinationNodeConstructor), (intptr_t)0 THUNK_GENERATOR(0) },
    { 0, 0, 0, 0 THUNK_GENERATOR(0) }
};

#undef THUNK_GENERATOR
static JSC_CONST_HASHTABLE HashTable JSAudioDestinationNodeTable = { 5, 3, JSAudioDestinationNodeTableValues, 0 };
/* Hash table for constructor */
#if ENABLE(JIT)
#define THUNK_GENERATOR(generator) , generator
#else
#define THUNK_GENERATOR(generator)
#endif

static const HashTableValue JSAudioDestinationNodeConstructorTableValues[1] =
{
    { 0, 0, 0, 0 THUNK_GENERATOR(0) }
};

#undef THUNK_GENERATOR
static JSC_CONST_HASHTABLE HashTable JSAudioDestinationNodeConstructorTable = { 1, 0, JSAudioDestinationNodeConstructorTableValues, 0 };
class JSAudioDestinationNodeConstructor : public DOMConstructorObject {
public:
    JSAudioDestinationNodeConstructor(JSC::ExecState*, JSC::Structure*, JSDOMGlobalObject*);

    virtual bool getOwnPropertySlot(JSC::ExecState*, const JSC::Identifier&, JSC::PropertySlot&);
    virtual bool getOwnPropertyDescriptor(JSC::ExecState*, const JSC::Identifier&, JSC::PropertyDescriptor&);
    static const JSC::ClassInfo s_info;
    static JSC::Structure* createStructure(JSC::JSGlobalData& globalData, JSC::JSValue prototype)
    {
        return JSC::Structure::create(globalData, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), AnonymousSlotCount, &s_info);
    }
protected:
    static const unsigned StructureFlags = JSC::OverridesGetOwnPropertySlot | JSC::ImplementsHasInstance | DOMConstructorObject::StructureFlags;
};

const ClassInfo JSAudioDestinationNodeConstructor::s_info = { "AudioDestinationNodeConstructor", &DOMConstructorObject::s_info, &JSAudioDestinationNodeConstructorTable, 0 };

JSAudioDestinationNodeConstructor::JSAudioDestinationNodeConstructor(ExecState* exec, Structure* structure, JSDOMGlobalObject* globalObject)
    : DOMConstructorObject(structure, globalObject)
{
    ASSERT(inherits(&s_info));
    putDirect(exec->globalData(), exec->propertyNames().prototype, JSAudioDestinationNodePrototype::self(exec, globalObject), DontDelete | ReadOnly);
}

bool JSAudioDestinationNodeConstructor::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSAudioDestinationNodeConstructor, JSDOMWrapper>(exec, &JSAudioDestinationNodeConstructorTable, this, propertyName, slot);
}

bool JSAudioDestinationNodeConstructor::getOwnPropertyDescriptor(ExecState* exec, const Identifier& propertyName, PropertyDescriptor& descriptor)
{
    return getStaticValueDescriptor<JSAudioDestinationNodeConstructor, JSDOMWrapper>(exec, &JSAudioDestinationNodeConstructorTable, this, propertyName, descriptor);
}

/* Hash table for prototype */
#if ENABLE(JIT)
#define THUNK_GENERATOR(generator) , generator
#else
#define THUNK_GENERATOR(generator)
#endif

static const HashTableValue JSAudioDestinationNodePrototypeTableValues[1] =
{
    { 0, 0, 0, 0 THUNK_GENERATOR(0) }
};

#undef THUNK_GENERATOR
static JSC_CONST_HASHTABLE HashTable JSAudioDestinationNodePrototypeTable = { 1, 0, JSAudioDestinationNodePrototypeTableValues, 0 };
const ClassInfo JSAudioDestinationNodePrototype::s_info = { "AudioDestinationNodePrototype", &JSC::JSObjectWithGlobalObject::s_info, &JSAudioDestinationNodePrototypeTable, 0 };

JSObject* JSAudioDestinationNodePrototype::self(ExecState* exec, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSAudioDestinationNode>(exec, globalObject);
}

const ClassInfo JSAudioDestinationNode::s_info = { "AudioDestinationNode", &JSAudioNode::s_info, &JSAudioDestinationNodeTable, 0 };

JSAudioDestinationNode::JSAudioDestinationNode(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<AudioDestinationNode> impl)
    : JSAudioNode(structure, globalObject, impl)
{
    ASSERT(inherits(&s_info));
}

JSObject* JSAudioDestinationNode::createPrototype(ExecState* exec, JSGlobalObject* globalObject)
{
    return new (exec) JSAudioDestinationNodePrototype(exec->globalData(), globalObject, JSAudioDestinationNodePrototype::createStructure(exec->globalData(), JSAudioNodePrototype::self(exec, globalObject)));
}

bool JSAudioDestinationNode::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSAudioDestinationNode, Base>(exec, &JSAudioDestinationNodeTable, this, propertyName, slot);
}

bool JSAudioDestinationNode::getOwnPropertyDescriptor(ExecState* exec, const Identifier& propertyName, PropertyDescriptor& descriptor)
{
    return getStaticValueDescriptor<JSAudioDestinationNode, Base>(exec, &JSAudioDestinationNodeTable, this, propertyName, descriptor);
}

JSValue jsAudioDestinationNodeNumberOfChannels(ExecState* exec, JSValue slotBase, const Identifier&)
{
    JSAudioDestinationNode* castedThis = static_cast<JSAudioDestinationNode*>(asObject(slotBase));
    UNUSED_PARAM(exec);
    AudioDestinationNode* imp = static_cast<AudioDestinationNode*>(castedThis->impl());
    JSValue result = jsNumber(imp->numberOfChannels());
    return result;
}


JSValue jsAudioDestinationNodeConstructor(ExecState* exec, JSValue slotBase, const Identifier&)
{
    JSAudioDestinationNode* domObject = static_cast<JSAudioDestinationNode*>(asObject(slotBase));
    return JSAudioDestinationNode::getConstructor(exec, domObject->globalObject());
}

JSValue JSAudioDestinationNode::getConstructor(ExecState* exec, JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSAudioDestinationNodeConstructor>(exec, static_cast<JSDOMGlobalObject*>(globalObject));
}

JSC::JSValue toJS(JSC::ExecState* exec, JSDOMGlobalObject* globalObject, AudioDestinationNode* impl)
{
    return wrap<JSAudioDestinationNode>(exec, globalObject, impl);
}


}

#endif // ENABLE(WEB_AUDIO)
