/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#ifndef JSWebKitAnimation_h
#define JSWebKitAnimation_h

#include "JSDOMBinding.h"
#include <runtime/JSGlobalObject.h>
#include <runtime/JSObjectWithGlobalObject.h>
#include <runtime/ObjectPrototype.h>

namespace WebCore {

class WebKitAnimation;

class JSWebKitAnimation : public JSDOMWrapper {
    typedef JSDOMWrapper Base;
public:
    JSWebKitAnimation(JSC::Structure*, JSDOMGlobalObject*, PassRefPtr<WebKitAnimation>);
    static JSC::JSObject* createPrototype(JSC::ExecState*, JSC::JSGlobalObject*);
    virtual bool getOwnPropertySlot(JSC::ExecState*, const JSC::Identifier& propertyName, JSC::PropertySlot&);
    virtual bool getOwnPropertyDescriptor(JSC::ExecState*, const JSC::Identifier& propertyName, JSC::PropertyDescriptor&);
    virtual void put(JSC::ExecState*, const JSC::Identifier& propertyName, JSC::JSValue, JSC::PutPropertySlot&);
    static const JSC::ClassInfo s_info;

    static JSC::Structure* createStructure(JSC::JSGlobalData& globalData, JSC::JSValue prototype)
    {
        return JSC::Structure::create(globalData, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), AnonymousSlotCount, &s_info);
    }

    static JSC::JSValue getConstructor(JSC::ExecState*, JSC::JSGlobalObject*);

    // Custom attributes
    JSC::JSValue iterationCount(JSC::ExecState*) const;
    WebKitAnimation* impl() const { return m_impl.get(); }

private:
    RefPtr<WebKitAnimation> m_impl;
protected:
    static const unsigned StructureFlags = JSC::OverridesGetOwnPropertySlot | Base::StructureFlags;
};

JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject*, WebKitAnimation*);
WebKitAnimation* toWebKitAnimation(JSC::JSValue);

class JSWebKitAnimationPrototype : public JSC::JSObjectWithGlobalObject {
    typedef JSC::JSObjectWithGlobalObject Base;
public:
    static JSC::JSObject* self(JSC::ExecState*, JSC::JSGlobalObject*);
    static const JSC::ClassInfo s_info;
    virtual bool getOwnPropertySlot(JSC::ExecState*, const JSC::Identifier&, JSC::PropertySlot&);
    virtual bool getOwnPropertyDescriptor(JSC::ExecState*, const JSC::Identifier&, JSC::PropertyDescriptor&);
    static JSC::Structure* createStructure(JSC::JSGlobalData& globalData, JSC::JSValue prototype)
    {
        return JSC::Structure::create(globalData, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), AnonymousSlotCount, &s_info);
    }
    JSWebKitAnimationPrototype(JSC::JSGlobalData& globalData, JSC::JSGlobalObject* globalObject, JSC::Structure* structure) : JSC::JSObjectWithGlobalObject(globalData, globalObject, structure) { }
protected:
    static const unsigned StructureFlags = JSC::OverridesGetOwnPropertySlot | Base::StructureFlags;
};

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsWebKitAnimationPrototypeFunctionPlay(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsWebKitAnimationPrototypeFunctionPause(JSC::ExecState*);
// Attributes

JSC::JSValue jsWebKitAnimationName(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsWebKitAnimationDuration(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsWebKitAnimationElapsedTime(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
void setJSWebKitAnimationElapsedTime(JSC::ExecState*, JSC::JSObject*, JSC::JSValue);
JSC::JSValue jsWebKitAnimationDelay(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsWebKitAnimationIterationCount(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsWebKitAnimationPaused(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsWebKitAnimationEnded(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsWebKitAnimationDirection(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsWebKitAnimationFillMode(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsWebKitAnimationConstructor(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
// Constants

JSC::JSValue jsWebKitAnimationDIRECTION_NORMAL(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsWebKitAnimationDIRECTION_ALTERNATE(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsWebKitAnimationFILL_NONE(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsWebKitAnimationFILL_BACKWARDS(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsWebKitAnimationFILL_FORWARDS(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);
JSC::JSValue jsWebKitAnimationFILL_BOTH(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);

} // namespace WebCore

#endif
